var gulp;

gulp = require('gulp');


/**
  @param {(string|Array.<string>)} paths
  @param {Object=} options
  @return {Stream} Node.js Stream.
 */

module.exports = function(paths, options) {
  var cond, gutil, jsx, plumber, ref, ref1, rename, renameCallback;
  if (options == null) {
    options = {};
  }
  cond = require('gulp-cond');
  gutil = require('gulp-util');
  jsx = require('gulp-react');
  plumber = require('gulp-plumber');
  rename = require('gulp-rename');

  /*
  Example:
    gulp.task 'jsx', ->
      este.jsx paths.jsx
   */
  renameCallback = (ref = options.rename) != null ? ref : function() {};
  if (!Array.isArray(paths)) {
    paths = [paths];
  }
  return gulp.src((ref1 = this.changedFilePath) != null ? ref1 : paths, {
    base: '.'
  }).pipe(cond(this.changedFilePath, plumber())).pipe(jsx({
    harmony: true
  })).on('error', function(err) {
    return gutil.log(gutil.colors.red(err.fileName + ': ' + err.message));
  }).pipe(rename(function(path) {
    renameCallback(path);
  })).pipe(gulp.dest('.'));
};
