
/**
  @param {Array.<string>} dirs
  @param {Object} mapExtensionToTask
  @param {Function} gulpStartCallback
  @param {Object=} options
 */
module.exports = function(dirs, mapExtensionToTask, gulpStartCallback, options) {
  var esteWatch, path, watch;
  if (options == null) {
    options = {};
  }
  esteWatch = require('este-watch');
  path = require('path');
  if (options.ignoredDirs == null) {
    options.ignoredDirs = ['build'];
  }
  watch = esteWatch(dirs, (function(_this) {
    return function(e) {
      var dir, filePath, i, len, ref, task;
      filePath = path.resolve(e.filepath);
      ref = options.ignoredDirs;
      for (i = 0, len = ref.length; i < len; i++) {
        dir = ref[i];
        if (filePath.indexOf(dir + path.sep) > -1) {
          return;
        }
      }
      _this.changedFilePath = filePath;
      task = mapExtensionToTask[e.extension];
      if (task) {
        return gulpStartCallback(task);
      } else {
        return _this.changedFilePath = null;
      }
    };
  })(this));
  return watch.start();
};
